defmodule ABNF.CaptureResult do
  @moduledoc """
  Capture result, used when returning a result after applying a grammar to an
  input.

      Copyright 2015 Marcelo Gornstein <marcelog@gmail.com>

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

      http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  """

  defstruct input: '', # original input before match
    rest: '',          # text that didn't match
    string_text: '',   # full text that matched
    string_tokens: [], # contains string parts that matched (usually 1)
    values: nil,       # real rule value
    state: nil         # state after match

  @type t :: %ABNF.CaptureResult{}
end